program Phylo;


uses
  Forms,
  SysUtils,
  Dialogs,
  PhylMain in 'PhylMain.pas' {FormPrinc},
  PhylObs in 'PhylObs.pas' {FormObs},
  BarreIc in 'BarreIc.pas' {BarreIcones},
  Donnees in 'Donnees.pas',
  PhylAbout in 'PhylAbout.pas' {AboutBox},
  PhylBig in 'PhylBig.pas' {FormBig},
  PhylChoi in 'PhylChoi.pas' {FormChoisir},
  PhylPlch in 'PhylPlch.pas' {FormPlanche},
  PhylComp in 'PhylComp.pas' {FormComp},
  MyNewGrid in 'MyNewGrid.pas',
  PhylMol in 'PhylMol.pas' {FormMol},
  OptionsMol in 'OptionsMol.pas' {OptionForm},
  PhylTrier in 'PhylTrier.pas' {FormTri},
  BarreCar in 'BarreCar.pas' {BarreCaract},
  PhylDef in 'PhylDef.pas' {FormDefinition},
  TabGridMark in 'TabGridMark.pas',
  GraphControlTreeCL in 'GraphControlTreeCL.pas',
  PhylGlo in 'PhylGlo.pas' {FormGlossaire},
  group2 in 'group2.pas',
  CompCadreIma2 in 'CompCadreIma2.pas',
  boite in 'boite.pas',
  GraphTri3 in 'GraphTri3.pas',
  phylParente in 'phylParente.pas' {FormParente},
  gestimpr in 'gestimpr.pas' {gestimp},
  ConstrucCol in 'ConstrucCol.pas' {ConstructionCollection},
  utils in 'utils.pas',
  chxCoul in 'chxCoul.pas' {ChCoul},
  ChxCPH in 'ChxCPH.pas' {DialogChxCPH},
  DialogNomCol in 'DialogNomCol.pas' {ChxNomCol},
  chxcphg in 'chxcphg.pas' {choixCPHG},
  AfDocs in 'AfDocs.pas' {AfficheDocs},
  chgNom in 'chgNom.pas' {ChangeNom},
  FenCaractAncetre in 'FenCaractAncetre.pas' {FicheCarAncetre},
  FicEssai in 'FicEssai.pas' {FicheEssai},
  EditeCarD in 'EditeCarD.pas' {FormModifcaracD},
  AffichTabCode in 'AffichTabCode.pas' {AffTabCode},
  PhyloRech in 'PhyloRech.pas' {FormRecherche},
  AffichTabCod in 'AffichTabCod.pas' {AffTabCod},
  ChxAffCell in 'ChxAffCell.pas' {FormChoixAffCell},
  Nmgroup in 'Nmgroup.pas' {FormGroupe},
  FenTabDist in 'FenTabDist.pas' {FormTabDist},
  phylClasser6 in 'phylClasser6.pas' {FormClasser6},
  ChxTaxAClasser in 'ChxTaxAClasser.pas' {FormChxTaxonsAClasser},
  phylDater in 'phylDater.pas' {FormDater},
  phylParenteLyc in 'phylParenteLyc.pas' {FormParenteLyc},
  StructureDonnees in 'StructureDonnees.pas',
  PhylConfig in 'PhylConfig.pas' {FormConfig},
  AffArbre in 'AffArbre.pas' {FormAffArbre},
  ChxNom in 'ChxNom.pas' {DialogNom},
  InfoVersion in 'InfoVersion.pas' {FInfoVersion},
  ChoixFicArbre in 'ChoixFicArbre.pas' {FormChoixFicArbre},
  FormConfigProf in 'FormConfigProf.pas' {ConfigProf},
  FNouvCar in 'FNouvCar.pas' {FicNouvCar},
  DemandeNom in 'DemandeNom.pas' {FDNom},
  chxCoulGroupe in 'chxCoulGroupe.pas' {ChoixCouleursGroupes},
  demmotcle in 'demmotcle.pas' {FdemMotCle},
  FCodeCoulSeq in 'FCodeCoulSeq.pas' {FormCodCoul},
  GestionTextes in 'GestionTextes.pas';

{$R *.RES}
type
  TT_Exceptions=class
    private
    public
     constructor TT_Create;
     procedure Handle(Sender:TObject;E:Exception);
  end;

var
  T_Exceptions : TT_Exceptions;
  
constructor TT_Exceptions.TT_Create;
begin
   inherited Create;
   Application.OnException:=Self.Handle;
end;

procedure SpecialTerminate;
begin
   T_Exceptions.Free;
   FormPrinc.ToutFermer(FormPrinc);
   Application.Terminate;
end;

procedure TT_Exceptions.Handle(Sender:TObject;E:Exception);
const
  CRLF=#13#10;
begin
  MessageDlg('Une erreur inopine s''est produite :'+CRLF+
              '"'+E.Message+'"'+CRLF+CRLF+
              'dans l''objet'+Sender.ClassName
             ,mtError,[mbOK],0);
  SpecialTerminate;
end;

begin
  T_Exceptions:= TT_Exceptions.TT_Create;
  Application.Initialize;
  Application.CreateForm(TFormPrinc, FormPrinc);
  Application.CreateForm(TFInfoVersion, FInfoVersion);
  Application.CreateForm(TConfigProf, ConfigProf);
  Application.CreateForm(TFicNouvCar, FicNouvCar);
  Application.CreateForm(TFDNom, FDNom);
  Application.CreateForm(TFormCodCoul, FormCodCoul);
  if FormPrinc.ArretDemande then
    begin
      SpecialTerminate;
      exit;
    end;
  Application.CreateForm(TBarreIcones, BarreIcones);
  Application.CreateForm(TFormPlanche, FormPlanche);
  Application.CreateForm(TFormObs, FormObs);
  Application.CreateForm(TFormComp, FormComp);
  Application.CreateForm(TFormChoisir, FormChoisir);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TFormMol, FormMol);
  Application.CreateForm(TOptionForm, OptionForm);
  Application.CreateForm(TFormTri, FormTri);
  Application.CreateForm(TFormDefinition, FormDefinition);
  Application.CreateForm(TFormGlossaire, FormGlossaire);
  Application.CreateForm(TFormParente, FormParente);
  Application.CreateForm(Tgestimp, gestimp);
  Application.CreateForm(TChCoul, ChCoul);
  Application.CreateForm(TDialogChxCPH, DialogChxCPH);
  Application.CreateForm(TchoixCPHG, choixCPHG);
  Application.CreateForm(TAfficheDocs, AfficheDocs);
  Application.CreateForm(TChangeNom, ChangeNom);
  Application.CreateForm(TFicheCarAncetre, FicheCarAncetre);
  Application.CreateForm(TFicheEssai, FicheEssai);
  Application.CreateForm(TFormModifcaracD, FormModifcaracD);
  Application.CreateForm(TAffTabCode, AffTabCode);
  Application.CreateForm(TFormRecherche, FormRecherche);
  Application.CreateForm(TAffTabCod, AffTabCod);
  Application.CreateForm(TFormChoixAffCell, FormChoixAffCell);
  Application.CreateForm(TFormGroupe, FormGroupe);
  Application.CreateForm(TFormTabDist, FormTabDist);
  Application.CreateForm(TFormClasser6, FormClasser6);
  Application.CreateForm(TFormChxTaxonsAClasser, FormChxTaxonsAClasser);
  Application.CreateForm(TFormDater, FormDater);
  Application.CreateForm(TFormParenteLyc, FormParenteLyc);
  Application.CreateForm(TFormConfig, FormConfig);
  FormPrinc.InitColParDefaut;
  Application.Run;
end.
